/*
    LPD: Decode an LP file to a TGA file

    05/01/97 JSP Creation
*/

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>

#include "lp.h"
#include "tga.h"

enum { LEVELS = 5 };

main (int argc, char **argv)
{
    try
    {
        if (argc != 3)
            throw "usage: lpd <lp filename> <tga filename>";

        cout << endl << argv[1] << ": " << flush;

        LP lp (argv[1]);
        
        unsigned width;
        unsigned height;

        lp.GetDimensions (0, width, height);

        cout << width << " X " << height << " greyscale image" << endl << endl;

        lp.Unquantize ();
        lp.Decompress ();

        TGA tga;

        tga.Load (width, 
            height, 
            8, // bpp
            TGA_GREY_SCALE,
            lp.GetRImage (0));

        cout << "Saving " << argv[2] << endl;

        tga.Save (argv[2]);

        return 0;
    }
    catch (const char *e)
    {
        cerr << e << endl;

        return -1;
    }
}
